import { world, system, EquipmentSlot} from "@minecraft/server";
import { launchPlayer } from "./../../util/movements.js";
import { weaponDamageIndicator, generateUniqueId, stunDamageIndicator } from "./../../util/utils.js";
import { attackPlayerMeikyu, executer } from "./../../util/attackMethods.js";

const animations =[ 
    [
        {
            animation: "minced.katar.attack_sprint",
            knockback: [2,0.25],
            Player_Knockback: [3,0],
            type: "pierce",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack0",
            knockback: [0,0],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 0.5,
            targetNum: 1,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.85,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack1",
            knockback: [0,0.25],
            Player_Knockback: [-0.25,0],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 0.5,
            targetNum: 1,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.85,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack2",
            knockback: [0.25,0],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 0.5,
            targetNum: 1,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 0.5,
            next_attack_time: 5,
            Unbreakable: false
        }
    ]
]

const dual_wield =[ 
    [
        {
            animation: "minced.katar.attack_sprint",
            knockback: [2,0.75],
            Player_Knockback: [1,0.25],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 10,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_dual_wield0",
            knockback: [0,0.25],
            Player_Knockback: [1,0.25],
            type: "pierce",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.5,
            next_attack_time: 8,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_dual_wield1",
            knockback: [0,0.25],
            Player_Knockback: [3,0],
            type: "slash",
            attack_speed: 6,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 8,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_dual_wield2",
            knockback: [0,0.25],
            Player_Knockback: [3,0],
            type: "pierce",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.5,
            next_attack_time: 8,
            Unbreakable: false
        }
    ]
]
const offhand =[ 
    [
        {
            animation: "minced.katar.attack_sprint",
            knockback: [2,0.75],
            Player_Knockback: [1,0.25],
            type: "slash",
            attack_speed: 6,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 10,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_offhand0",
            knockback: [0,0.25],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 6,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.5,
            next_attack_time: 4,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_offhand1",
            knockback: [0,0.25],
            Player_Knockback: [-1,0],
            type: "slash",
            attack_speed: 6,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 4,
            Unbreakable: false
        },
        {
            animation: "minced.katar.attack_offhand2",
            knockback: [0,0.25],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 6,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1.35,
            stun_damage_multiplier: 0.35,
            next_attack_time: 4,
            Unbreakable: false
        }
    ]
]

const weapon = {
    name: 'katar',
    display_name: "Katar",
    dual_wield: ["katar", "sword", "longsword", "rapier", "gauntlet"],
    type: "katar",
    can_block: false,
    block_damage: 50,
    block_power: 10,
    block_time: 2,
    clash_power: 15,
    front_dodge: [2, 0.2],
    back_dodge:[-2, 0.2],
    left_dodge:[3, 0.2],
    right_dodge:[3, 0.2],
    stylePrefixes: ["minced.katar"],
    weaponSize: "small",
    cd: 8,
    available_moves: ["flying"],
    execute(player, weapon, effect, mode, burn) {
        const cd = this.cd
        const blckdmg = this.block_damage
        let atkspd
        let lavander = weaponDamageIndicator(weapon)
        let stundamage = stunDamageIndicator(weapon.getTags())
        let critChance = Math.floor(Math.random()*9)
        let critDamage = 0
        critChance == 2 ? critDamage = Math.floor(Math.random() * lavander) : critDamage = 0
        lavander = JSON.parse(lavander) + critDamage
        let animChecker
        for(let i = animations[0].length - 1; i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        let attackEffect = []
        attackEffect.push(effect)
        switch(mode) {
            case "sprint":{
                let propCheck = animations[0][0]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },(atkspd - 4))
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, false)
            } break;
            case "offhand":{
                let propCheck = offhand[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, offhand[0].length - 1, stunD, NAT, breakable, "normal",weapon, hitCount, false)
            } break;
            case "dual_wield":{
                let propCheck = dual_wield[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, dual_wield[0].length - 1, stunD, NAT, breakable, "normal",weapon, hitCount, false)
            } break;
            case "jump": {
                let propCheck = {
                    animation: "minced.katar.attack_jump",
                    knockback: [1,0],
                    Player_Knockback: [0,-0.5],
                    type: "slash",
                    attack_speed: 7,
                    hit_number: 1,
                    stun_type: "short",
                    range: 3,
                    distance: 1,
                    targetNum: 1,
                    damage_multiplier: 1.75,
                    stun_damage_multiplier: 1,
                    next_attack_time: 10,
                    Unbreakable: false
                }
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, false)
            } break; 
            case "execute": {
                let propCheck =  {
                    animation: "minced.katar.attack_execute",
                    knockback: [2,0.5],
                    Player_Knockback: [0,0],
                    type: "pierce",
                    attack_speed: 9,
                    hit_number: 1,
                    stun_type: "medium",
                    range: 3,
                    distance: 1,
                    targetNum: 1,
                    damage_multiplier: 2.5,
                    stun_damage_multiplier: 0.25,
                    next_attack_time: 10,
                    Unbreakable: false
                }
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                attackPlayerMeikyu(player, ranger, ((lavander * propCheck.damage_multiplier) * 1.5), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, 1, stunD, NAT, breakable, "no cooldown",weapon, hitCount, false)
            } break;
            default: {
                let propCheck = animations[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, false)
            }
            break;
        }
    },
    setCore(player, item) {
        let Abilities = [
            {
              Id: "S1",
            },
            {
              Id: "P3",
            },
            {
              Id: "O0",
            },
            {
              Id: "B3",
            },
            {
              Id: "O0",
            }
          ]
          item.setDynamicProperty("abilities", JSON.stringify(Abilities))
          item.setDynamicProperty("fightStyle", 1)
        player.getComponent('equippable')?.setEquipment(EquipmentSlot.Mainhand, item)
    },
    getCurrentAtkspd(player) {
        let animChecker
        for(let i = (animations[0].length - 1); i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        return animations[0][animChecker].attack_speed
    } 
}

export default weapon


